;*** AS V1.00 PROGRAM: ONE-PASS ASSEMBLER  -  BY RAIG RUCE  -  15-CT-1994

; HIS IS THE UDDY-ASSEMBLER VERSION OF THE PROGRAM

;TODO: -IMPLEMENT STORAGE CLASSES: $00=INTERNAL, $01=REL.LABEL, $80=EXPORTED
;      -IMPLEMENT ALL VAR TYPES: 0=VALUE, 1=ADDRESS, 2=ADDR.HIGH, 3=ADDR.LOW
;      -IMPLEMENT SOURCE COLUMN, MAKE LINE:COL POINT TO START OF CUR TOKEN
;      -MAKE IT SO YOU CAN USE A "\<>" TO CONTINUE A LINE
;      -ADD MORE OPERATORS: * / &    FULL PRECEDENCE?
;      -CACHE CURRENT SYMBOL
;      -SUBTLE PROBLEM: SHORT BLOCKS ON READ WILL CAUSE TOKENS TO BE SPLIT
;       BECAUSE OF BUFFER FILLING WITH SPACES.  SOLUTION: PUSH SHORT BLOCKS
;       TO HIGH END OF BUFFER, SET POINTER?  BETTER SOLUTION: READ UNTIL
;       BUFFER IS FULL OR EOF IS HIT.

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:AS"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;======== GLOBAL DECLARATIONS ========

SOURCECB     =  2  ;(1)   ;FILE CONTROL BLOCK OF CURRENT INPUT FILE
BUFPTR        =  3  ;(1)   ;BYTE OFFSET INSIDE OF SOURCE BUFFER
SOURCEINE    =  4  ;(4)   ;SOURCE FILE CURRENT LINE
NUMBER        =  8  ;(4)   ;TOKEN: 32-BIT NUMBER VALUE
STRINGEN     = 12  ;(1)   ;LENGTH OF STRING IN STRING BUFFER
PREVHAR      = 13  ;(1)   ;PREVIOUS CHARACTER SCANNED, NEXT READ (1-TOO-FAR)
TOKENYPE     = 14  ;(1)   ;TOKEN: TYPE 
TOKENEXTHAR = 15  ;(1)   ;TOKEN: NEXT CHAR AFTER TOKEN
TOKENUMYTES = 16  ;(1)   ;TOKEN: NUMBER LENGTH (1-4 BYTES)
TOKENHAR     = 17  ;(1)   ;TOKEN: CHARACTER
NAME          = 18  ;(2)   ;POINTER TO SOURCE FILENAME
SOURCEOL     = 20  ;(1)   ;SOURCE FILE COLUMN WITHIN LINE
NEXTLUSAB   = 22  ;(4)   ;NUMBER FOR NEXT "+" LABEL
PREVINUSAB  = 26  ;(4)   ;NUMBER FOR PREVIOUS "-" LABEL
ADDRESS       = 30  ;(4)   ;CURRENT MEMORY ADDRESS FOR CODE ASSEMBLY
HASHAL       = 34  ;(2)   ;16-BIT HASH VALUE RESULT
HASHTR       = 36  ;(2)   ;POINTER TO SELECTED ENTRY IN IDENTIFIER HASH TABLE
IDTR         = 38  ;(4)   ;POINTER TO CURRENT IDENTIFIER DESCRIPTOR
IDAL         = 42  ;(4)   ;VALUE OF CURRENT IDENTIFIER
VARTR        = 46  ;(4)   ;POINTER TO CURRENT IDENTIFIER TO BE DEFINED
FILETR       = 50  ;(4)   ;POINTER TO CURRENT FILE INFO DESCRIPTOR
IDYPE        = 54  ;(1)   ;TYPE OF CURRENT IDENTIFIER (VALUE,ADDRESS,UNRES)
ORIGINET     = 55  ;(1)   ;FLAG INDICATING WHETHER ORIGIN HAS BEEN SET
EXPLUSOUNT  = 56  ;(1)   ;NUMBER OF PLUS MONADIC OPERATORS OF AN OPERAND
EXPINUSOUNT = 57  ;(1)   ;NUMBER OF MINUS MONADIC OPERATORS OF AN OPERAND
EXPESSOUNT  = 58  ;(1)   ;NUMBER OF LOW-BYTE MONADIC OPERATORS OF AN OPERAND
EXPREATEROUNT = 59 ;(1)  ;NUMBER OF HIGH-BYTE MONADIC OPERATORS OF AN OPERAND
EXPFFSET     = 60  ;(1)   ;OFFSET OF CUR OPERAND IN AN EXPRESSION DESCRIPTOR
EXPTR        = 62  ;(4)   ;POINTER TO EXPRESSION DESCRIPTOR IN FAR MEMORY
ADDRESSRIGIN = 66  ;(4)   ;ORIGIN AS SET BY ORG DIRECTIVE
HOLEOUNT     = 70  ;(4)   ;NUMBER OF HOLES (UNRESOLVED REFERENCES)
RELOLEOUNT  = 74  ;(4)   ;NUMBER OF HOLES FOR RELATIVE (INTERNAL) REFERENCES
INSTRUM      = 78  ;(1)   ;ASSEM INSTR: INSTRUCTION NUMBER (1-56)
INSTRDDRODE = 79  ;(1)   ;ASSEM INSTR: ADDRESSING MODE FOR INSTR (1-12)
INSTRALUE    = 80  ;(2)   ;ASSEM INSTR: OPERAND VALUE FOR INSTR (8/16 BIT)
INSTRALUEYPE = 82 ;(1)   ;ASSEM INSTR: OPERAND VALUE TYPE
INSTRPCODE   = 83  ;(1)   ;ASSEM INSTR: OPCODE OF INSTR/ADDRMODE
INSTREN      = 84  ;(1)   ;ASSEM INSTR: LENGTH OF INSTRUCTION
MEMUFAGE    = 85  ;(1)   ;MEM PUT: PAGE OF BUFFER
MEMUFTR     = 86  ;(4)   ;MEM PUT: POINTER TO 1 MEMORY-BUFFER BLOCK
MEMUTALS    = 90  ;(4)   ;MEM PUT: VALUES TO PUT INTO MEMORY
MEMUTOUNT   = 94  ;(1)   ;MEM PUT: NUMBER OF VALUES TO PUT INTO MEMORY
MEMUTAGE    = 95  ;(1)   ;MEM PUT: CURRENT PAGE FOR VALUES
NEWINE       = 96  ;(4)   ;CURRENT INPUT LINE
NEWOL        = 100 ;(1)   ;CURRENT INPUT COLUMN
ARG           = 102 ;(2)   ;CURRENT COMMAND LINE ARGUMENT
RESERVED      = 104
MEMORK       = 112 ;(16)  ;WORK AREA FOR THE MEMORY ROUTINES/LOW-LEVEL WORK
STRELIMIT    = 112 ;(1)   ;STRING TOKENIZE: DELIMITER--OVERLAP
NUMASE       = 113 ;(1)   ;NUMBER TOKENIZE: BASE--OVERLAP
NUMAVE       = 114 ;(4)   ;NUMBER TOKENIZE: SAVE--OVERLAP
WORK          = 112 ;(16)  ;MISCELLANEOUS WORK--LOW-LEVEL--OVERLAP

HASHABLEAGES = 16
HASHABLENTRIESIGH = 4
HASHABLEASK  = $03
SYMEW = $81
SYMNRESOLVED = $80
SYMOUND = 0

TOKENDENTIFIER = 0
TOKENUMBER  = 1
TOKENTRING  = 2
TOKENPECIAL = 3
TOKEN     = 4

CHR = $0D
CHRUOTE = $22
CHRAB = $09
CHR = $00

ERRK            = 0       ;OK
ERRDENTOOONG  = 1       ;AN IDENTIFIER TOKEN EXCEEDS 240 CHARS IN LENGTH
ERRTRINGOOONG = 2       ;A STRING LITERAL EXCEEDS 255 CHARS IN LENGTH
ERROLOSEUOTE  = 3       ;RAN INTO A  BEFORE END OF STRING LITERAL
ERRADUMBER     = 4       ;INVALID NUMERIC LITERAL
ERRUMVERFLOW   = 5       ;NUMERIC LITERAL VALUE OVERFLOWS 32-BITS
ERRYNTAX        = 6       ;SYNTAX ERROR
ERRNVALTRPERS = 7       ;ATTEMPT TO PERFORM NUMERIC OPERATORS ON A STRING
ERROOANYPERANDS = 8     ;EXPRESSION HAS MORE THAN 17 OPERANDS
ERRNSUFFICIENTEMORY = 9  ;RAN OUT OF MEMORY DURING COMPILATION PROCESS
ERREDEFINEDYMBOL = 10    ;ATTEMPT TO REDEFINE A SYMBOL
ERRRIGINOTET  = 11      ;ATTEMPT TO ASSEMBLE CODE WITH CODE ORIGIN NOT SET
ERRNTERNSSIGN  = 12      ;INTERNAL ERROR: ATTEMPT TO ASSIGN TO UNEXPECTED ID
ERRONUMDXPR  = 13      ;NON-NUMERIC SYMBOL IN A NUMERIC EXPRESSION
ERRXPECTPERATOR = 14     ;EXPECTING AN OPERATOR
ERRXPECTPERAND = 15      ;EXPECTING AN OPERAND
ERRXPECTOMMAND = 16      ;EXPECTING A COMMAND
ERRALUEOOARGE = 17      ;VALUE IS TOO LARGE FOR OPERATION (OR IS NEGATIVE)
ERRRANCHOOAR  = 18      ;BRANCH OUT OF RANGE
ERROTMPLEMENTED = 19     ;FEATURE IS NOT (YET) IMPLEMENTED
ERRRONGDMODE   = 20      ;INSTRUCTION DOES NOT SUPPORT GIVEN ADDRESS MODE
ERRDDRESSRAP   = 21      ;ADDRESS WRAPED AROUND 64 CODE ADDRESS SPACE
ERRBJECTILE    = 22      ;ERROR TRYING TO WRITE OUTPUT OBJECT FILE
ERROTESOLVEDXPR = 23    ;DIRECTIVE REQUIRES RESOLVED EXPRESSION
ERRRIGINLREADYET = 24   ;CODE ORIGIN ALREADY SET; YOU CAN'T SET IT TWICE
ERRNRESDEFERENCES = 25   ;UNRESOLVED REFERENCE
ERROTOMMAND    = 26      ;THIS ASSEMBLER DOESN'T ACCEPT DOT COMMANDS

DEBUG      .BUF 1  ;DISPLAY DEBUG INFORMATION: $FF=YES, $00=NO
SYMUMP    .BUF 1  ;DISPLAY SYMBOL TABLE DUMP: $FF=YES, $00=NO
OUTPUTYPE .BUF 1  ;TYPE OF OUTPUT MODULE: $00=BINARY, $01=RELOC, $80=LINK

;======== MAIN ROUTINE ========

MAIN = *
   ;** CHECK FOR LARGE ENOUGH 
   SEC
   LDA #<BSSND
   CMP ACEEMOP+0
   LDA #>BSSND
   SBC ACEEMOP+1
   BCS +
   JMP MAINONT
+  LDA #<TPASG
   LDY #>TPASG
   JSR EPUTS
DIE = *
   LDA #1
   LDX #0
   JMP EXIT

TPASG = *
   .ASC "AS: NSUFFICIENT PROGRAM SPACE TO RUN IN"
   .BYTE CHR,0

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP DIE

USAGESG = *
   .ASC "USAGE: AS [-HELP] [-S] [-D] [FILE ...]"
   .BYTE CHR,CHR
   .ASC "       -HELP : PRODUCE THIS INFORMATION, DON'T RUN"
   .BYTE CHR
   .ASC "          -S : PRODUCE SYMBOL TABLE DUMP AT END"
   .BYTE CHR
   .ASC "          -D : PROVIDE DEBUGGING INFORMATION (LOTS)"
   .BYTE CHR,0

DEFAULTNPUT = *
   .ASC "-STDIN-"
   .BYTE 0

FILENAMESED .BUF 1

MAINONT = *
   ;** INIT GLOBALS
   LDA #$00
   STA DEBUG        ;DEFAULT OFF
   STA SYMUMP      ;DEFAULT NONE
   STA OUTPUTYPE   ;DEFAULT BINARY
   LDA #$00
   STA FILENAMESED
   LDA #0
   STA ARG+0
   STA ARG+1
   JSR ASNIT
   LDX #7
-  LDA WRITEEFAULTAME,X
   STA WRITEAME,X
   DEX
   BPL -

   MAINEXT = *
   JSR CHECKTOP
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   ORA ZP+1
   BEQ MAINXIT
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   JSR HANDLELAGS
   JMP MAINEXT
+  JSR ECHO
   JSR MAINILE
   JMP MAINEXT

MAINXIT = *
   BIT FILENAMESED
   BMI +
   LDA #<DEFAULTNPUT
   LDY #>DEFAULTNPUT
   STA NAME+0
   STY NAME+1
   JSR ECHO
   JSR MAINTDIN
+  LDA #$00
   LDX #3
-  ORA HOLEOUNT
   DEX
   BPL -
   CMP #$00
   BEQ +
   JSR FINDNRESYMBOL
   LDA #ERRNRESDEFERENCES
   JMP ERROREF
+  JSR WRITEBJECTILE
   JSR DUMPYMBOLABLE
   RTS

HANDLELAGS = *
   INY
   LDA (ZP),Y
   BNE +
   RTS
+  CMP #"S"
   BEQ FLAG
   CMP #"D"
   BEQ FLAG
   JMP USAGE

FLAG = *
   LDA #$FF
   STA SYMUMP
   JMP HANDLELAGS

FLAG = *
   LDA #$FF
   STA DEBUG
   JMP HANDLELAGS

ECHO = *
   LDA #<ECHOSG1
   LDY #>ECHOSG1
   JSR EPUTS
   JSR ECHOAME
   LDA #<ECHOSG2
   LDY #>ECHOSG2
   JMP EPUTS
ECHOAME = *
   LDA NAME+0
   LDY NAME+1
   JMP EPUTS

ECHOSG1 = *
   .ASC "ASSEMBLING SOURCE FILE "
   .BYTE CHRUOTE,0
ECHOSG2 = *
   .BYTE CHRUOTE,CHR,0

MAINILE = *
   BIT FILENAMESED
   BMI +
   JSR MAINXTRACTBJ
+  LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   JSR ECHOAME
   LDA #<MAINILERR
   LDY #>MAINILERR
   JSR EPUTS
   JMP DIE
+  STA SOURCECB
   JSR ASRIVER
   LDA SOURCECB
   JSR CLOSE
   LDA #$FF
   STA FILENAMESED
   RTS
MAINILERR = *
   .ASC ": ANNOT OPEN FILE"
   .BYTE CHR,0

MAINTDIN = *
   LDA #STDIN
   STA SOURCECB
   JSR ASRIVER
   RTS

MAINXTRACTBJ = *
   LDX #0 ;COPY-START
   LDY #0
-  LDA (NAME),Y
   BEQ +++
   CMP #":"
   BEQ +
   CMP #"/"
   BNE ++
+  TYA
   TAX
   INX
+  INY
   BNE -
+  TXA
   TAY
   LDX #0
-  LDA (NAME),Y
   STA STRINGUF,X
   BEQ +
   INY
   INX
   BNE -
+  NOP
-  CPX #3
   BCS +
   RTS
+  LDA STRINGUF-2,X
   CMP #","
   BNE +
   LDA #0
   DEX
   DEX
   STA STRINGUF,X
   JMP -
+  CMP #"."
   BEQ +
   RTS
+  LDA STRINGUF-1,X
   CMP #"S"
   BEQ +
   RTS
+  CPX #18
   BCC +
   LDX #18
+  LDA #","
   STA STRINGUF-2,X
   LDA #"P"
   STA STRINGUF-1,X
   LDA #0
   STA STRINGUF,X
-  LDA STRINGUF,X
   STA WRITEAME,X
   DEX
   BPL -
   RTS

ASNIT = *  ;INITIALIZE VARIABLES FOR ASSEMBLY
   LDX #3
   LDA #0
-  STA NEWINE,X
   STA NEXTLUSAB,X
   STA PREVINUSAB,X
   STA ADDRESS,X
   STA HOLEOUNT,X
   STA RELOLEOUNT,X
   DEX
   BPL -
   STA NEWOL
   LDA #1
   STA NEWINE+0
   STA NEXTLUSAB+0
   LDA #$00
   STA ORIGINET
   LDA #<$1300
   LDY #>$1300
   STA ADDRESS+0
   STY ADDRESS+1
   STA ADDRESSRIGIN+0
   STY ADDRESSRIGIN+1
   JSR MALLOCNIT
   JSR INITYMBOLABLE
   JSR MEMNIT
   RTS

;======== DRIVER ========

ASRIVER = *
   LDA #$FF
   STA BUFPTR
   LDA #" "
   STA PREVHAR
-  JSR PARSE
   BCC -
   RTS

WRITEBRY .BUF 1
WRITEBD  .BUF 1

WRITEBJECTILE = *
   LDA #<WRITESG
   LDY #>WRITESG
   JSR EPUTS
   LDA #<WRITEAME
   LDY #>WRITEAME
   JSR EPUTS
   LDA #CHRUOTE
   LDX #STDERR
   JSR PUTC
   LDX #STDERR
   LDA #CHR
   JSR PUTC
   LDA #2
   STA WRITEBRY
   LDA #<WRITEAME
   LDY #>WRITEAME
   STA ZP+0
   STY ZP+1

   ;** OPEN OBJECT FOR WRITING
-  LDA #"W"
   JSR OPEN
   BCC ++
   LDA ERRNO
   CMP #ACERRILEXISTS
   BEQ +
-  LDA #ERRBJECTILE
   JMP ERROR
+  DEC WRITEBRY
   BEQ -
   JSR REMOVE
   BCS -
   JMP --
+  STA WRITEBD

   ;** WRITE OBJECT DATA
   LDA ADDRESSRIGIN+0
   LDX WRITEBD
   JSR PUTC
   LDA ADDRESSRIGIN+1
   LDX WRITEBD
   JSR PUTC
   LDA WRITEBD
   LDX ADDRESSRIGIN+0
   LDY ADDRESSRIGIN+1
   JSR MEMAVE

   ;** CLOSE OBJECT
   LDA WRITEBD
   JSR CLOSE
   BCC +
   LDA #ERRBJECTILE
   JMP ERROR
+  LDA #<WRITEANGESG1
   LDY #>WRITEANGESG1
   JSR EPUTS
   LDA ADDRESSRIGIN+1
   LDX #STDERR
   JSR FPUTHEX
   LDA ADDRESSRIGIN+0
   LDX #STDERR
   JSR FPUTHEX
   LDA #<WRITEANGESG2
   LDY #>WRITEANGESG2
   JSR EPUTS
   SEC 
   LDA ADDRESS+0
   SBC #1
   PHA
   LDA ADDRESS+1
   SBC #0
   LDX #STDERR
   JSR FPUTHEX
   PLA
   LDX #STDERR
   JSR FPUTHEX
   LDA #<WRITEANGESG3
   LDY #>WRITEANGESG3
   JSR EPUTS
   SEC
   LDA ADDRESS+0
   SBC ADDRESSRIGIN+0
   STA WORK+0
   LDA ADDRESS+1
   SBC ADDRESSRIGIN+1
   STA WORK+1
   LDA #0
   STA WORK+2
   STA WORK+3
   LDX #WORK
   JSR EPUTNUM
   LDA #<WRITEANGESG4
   LDY #>WRITEANGESG4
   JSR EPUTS
   RTS

WRITEEFAULTAME = *
   .ASC "A.OUT,P"
   .BYTE 0
WRITESG = *
   .ASC "WRITING OBJECT FILE "
   .BYTE CHRUOTE,0
WRITEANGESG1 = *
   .ASC "CODE RANGE: $"
   .BYTE 0
WRITEANGESG2 = *
   .ASC "--$"
   .BYTE 0
WRITEANGESG3 = *
   .ASC " ("
   .BYTE 0
WRITEANGESG4 = *
   .ASC " BYTES)"
   .BYTE CHR,0

;======== PARSER ========

PARSE = *
   ;** AT BEGINNING OF COMMAND
   JSR CHECKTOP
   JSR GETOKEN
   LDA TOKENYPE
   CMP #TOKEN
   BNE +
   SEC
   RTS
+  CMP #TOKENDENTIFIER
   BNE PARSEOTD
   LDA TOKENEXTHAR
   CMP #"="
   BNE +
   JMP PARSEQUATE
+  CMP #":"
   BNE +
   JMP PARSEDDRESS
+  JMP PARSEDENTIFIER

PARSEOTD = *
   CMP #TOKENPECIAL
   BEQ +
   SYNTAXRROR = *
   LDA #ERRYNTAX
   JMP ERROR
+  LDA TOKENHAR
   CMP #CHR
   BNE +
   JMP PARSEND
+  CMP #"+"
   BNE +
   JMP PARSELUS
+  CMP #"-"
   BNE +
   JMP PARSEINUS
+  CMP #"#"
   BNE +
   JMP PARSEND
+  CMP #"."
   BNE +
   JMP PARSEOTOMMAND
+  JMP SYNTAXRROR

;RET: .=TOKENDENTIFIER, .=NEXTHAR, .=STRLEN, STRINGEN, STRINGUF
;     .=TOKENUMBER,     .=NUMLEN, NUMBER
;     .=TOKENTRING,     .=FIRSTHAR,.=STRLEN, STRINGEN, STRINGUF
;     .=TOKENPECIAL,    .=CHAR

PARSEQUATE = *
   JSR PARSEEFINEAR
   JSR GETOKEN
   CPX #TOKENPECIAL
   BEQ +
-  JMP SYNTAXRROR
+  CMP #"="
   BNE -
   LDA #0
   JSR PARSEXPRESSION
   CMP #CHR
   BNE -
   JSR EVALUATEXPRESSION
   BCS +
   JSR ASSIGNARIABLE
   JMP ++
+  JSR ADDARIABLEOLE
+  BIT DEBUG
   BPL +
   LDA #<PARSEQUATESG
   LDY #>PARSEQUATESG
   JSR PUTS
+  JMP PARSEND
   PARSEQUATESG = *
   .ASC "PARSEQUATE: ASSIGN PARSED EXPRESSION TO VARIABLE."
   .BYTE CHR,0

PARSEDDRESS = *
   JSR PARSEEFINEAR
   JSR GETOKEN
   CPX #TOKENPECIAL
   BEQ +
-  JMP SYNTAXRROR
+  CMP #":"
   BEQ +
   JMP SYNTAXRROR
+  JSR PARSESSIGNDDRESS
   BIT DEBUG
   BPL +
   LDA #<PARSEDDRESSSG
   LDY #>PARSEDDRESSSG
   JSR PUTS
+  JMP PARSEND
   PARSEDDRESSSG = *
   .ASC "PARSEDDRESS: ASSIGN CURRENT ADDRESS TO VARIABLE."
   .BYTE CHR,0

PARSESSIGNDDRESS = *
   BIT ORIGINET
   BMI +
   LDA #ERRRIGINOTET
   JMP ERROR
+  LDX #3
-  LDA ADDRESS,X
   STA IDAL,X
   DEX
   BPL -
   LDA #$01
   STA IDYPE
   JMP ASSIGNARIABLE

PARSELUS = *
   LDA #"+"
   LDY #0
   JSR GENELABEL
   JSR PARSEEFINEAR
   JSR PARSESSIGNDDRESS
   BIT DEBUG
   BPL +
   LDA #<PARSELUSSG
   LDY #>PARSELUSSG
   JSR PUTS
   LDX #NEXTLUSAB
   JSR PUTNUM
   LDA #CHR
   JSR PUTCHAR
+  INC NEXTLUSAB+0
   BNE +
   INC NEXTLUSAB+1
   BNE +
   INC NEXTLUSAB+2
   BNE +
   INC NEXTLUSAB+3
+  JMP PARSEND
   PARSELUSSG = *
   .ASC "PARSELUS: ASSIGN CURRENT ADDRESS TO A SYNTHEIC '+' VARIABLE:"
   .BYTE 0

PARSEINUS = *
   INC PREVINUSAB+0
   BNE +
   INC PREVINUSAB+1
   BNE +
   INC PREVINUSAB+2
   BNE +
   INC PREVINUSAB+3
+  LDA #"-"
   LDY #0
   JSR GENELABEL
   JSR PARSEEFINEAR
   JSR PARSESSIGNDDRESS
   BIT DEBUG
   BPL +
   LDA #<PARSEINUSSG
   LDY #>PARSEINUSSG
   JSR PUTS
   LDX #PREVINUSAB
   JSR PUTNUM
   LDA #CHR
   JSR PUTCHAR
+  JMP PARSEND
   PARSEINUSSG = *
   .ASC "PARSEINUS: ASSIGN CURRENT ADDRESS TO A SYNTHETIC '-' VARIABLE:"
   .BYTE 0

GENELABEL = *  ;( .=TYPE, .=RELATIVE )
   STA STRINGUF+1
   CMP #"+"
   BNE +
   CLC
   TYA
   ADC NEXTLUSAB
   STA NUMBER+0
   LDY #3
   LDX #1
-  LDA NEXTLUSAB,X
   ADC #0
   STA NUMBER,X
   INX
   DEY
   BNE -
   JMP ++
+  SEC
   STY NUMBER+0
   LDA PREVINUSAB+0
   SBC NUMBER+0
   STA NUMBER+0
   LDY #3
   LDX #1
-  LDA PREVINUSAB,X
   SBC #0
   STA NUMBER,X
   INX
   DEY
   BNE -
+  LDA #""
   STA STRINGUF+0
   LDA #<STRINGUF+2
   LDY #>STRINGUF+2
   STA ZP+0
   STY ZP+1
   LDX #NUMBER
   LDA #1
   JSR UTOA
   INY
   INY
   LDA #"C"
   STA STRINGUF,Y
   INY
   LDA #0
   STA STRINGUF,Y
   STY STRINGEN
   RTS

PARSEND = *
   BIT DEBUG
   BPL +
   LDA #<PARSENDSG
   LDY #>PARSENDSG
   JSR PUTS
+  CLC
   RTS
   PARSENDSG = *
   .ASC "-----=-----"
   .BYTE CHR,CHR,0

PARSEDENTIFIER = *  ;LINE STARTING WITH AN IDENTIFIER
   JSR HASH
   ;** CHECK IF IDENTIFIER IS A PROCESSOR INSTRUCTION
   LDA STRINGEN
   CMP #3
   BNE PARSEDOTNSTR
   LDA HASHAL+0
   AND #63
   TAX
   LDA INSTRASHTRS,X
   CMP #100
   BCS +
   JSR PARSEDHECKNSTR
   BCS PARSEDOTNSTR
   JMP INSTR
+  SEC
   SBC #100
   TAX
-  LDA INSTRASHNDIRECTS,X
   BEQ PARSEDOTNSTR
   JSR PARSEDHECKNSTR
   BCS +
   JMP INSTR
+  INX
   BNE -

   ;** CHECK IF IDENTIFIER IS A DIRECTIVE
   PARSEDOTNSTR = *
   JSR CHECKFIRECTIVE
   BCS PARSEDOTIRECTIVE
   JMP DIRECTIVE

   ;** CHECK IF IDENTIFIER IS A MACRO
   PARSEDOTIRECTIVE = *
   LDA #ERRXPECTOMMAND
   JMP ERROR

PARSEOTOMMAND = *
   LDA #ERROTOMMAND
   JMP ERROR

;======== HANDLE ASSEMBLER DIRECTIVES ========

DIRECUM .BUF 1

CHECKFIRECTIVE = *  ;( STRINGUF, STRINGEN ) : .=NO, .=DIRUM
   LDA #0
   STA DIRECUM

   DIRECHECKEXT = *
   LDX DIRECUM
   LDY DIRECFFSETS,X
   LDX #0
-  LDA STRINGUF,X
   CMP DIRECAMES,Y
   BNE DIRECHECKONT
   CMP #$00
   BNE +
   LDA DIRECUM
   CLC
   RTS
+  INY
   INX
   BNE -

   DIRECHECKONT = *
   INC DIRECUM
   LDA DIRECUM
   CMP #16
   BCC DIRECHECKEXT
   LDA #0
   SEC
   RTS

DIRECFFSETS = *
   .BYTE 00,03,07,10,13,16,20,28,31,37,42,48,54,63,70

DIRECAMES = *
   .ASC "DB"       ;DN=01.  OFF=00
   .BYTE 0
   .ASC "BUF"      ;DN=02.  OFF=03
   .BYTE 0
   .ASC "DW"       ;DN=03.  OFF=07
   .BYTE 0
   .ASC "DT"       ;DN=04.  OFF=10
   .BYTE 0
   .ASC "DL"       ;DN=05.  OFF=13
   .BYTE 0
   .ASC "ORG"      ;DN=06.  OFF=16
   .BYTE 0
   .ASC "INCLUDE"  ;DN=07.  OFF=20
   .BYTE 0
   .ASC "IF"       ;DN=08.  OFF=28
   .BYTE 0
   .ASC "ELSIF"    ;DN=09.  OFF=31
   .BYTE 0
   .ASC "ELSE"     ;DN=10.  OFF=37
   .BYTE 0
   .ASC "ENDIF"    ;DN=11.  OFF=42
   .BYTE 0
   .ASC "MACRO"    ;DN=12.  OFF=48
   .BYTE 0
   .ASC "ENDMACRO" ;DN=13.  OFF=54
   .BYTE 0
   .ASC "EXPORT"   ;DN=14.  OFF=63
   .BYTE 0
   .ASC "BSS"      ;DN=15.  OFF=70
   .BYTE 0

DIRECECTORS = *
   .WORD DIRECB,DIRECUF,DIRECW,DIRECT,DIRECL,DIRECRG,DIRECNCLUDE
   .WORD DIRECF,DIRECLSIF,DIRECLSE,DIRECNDIF,DIRECACRO,DIRECNDMACRO
   .WORD DIRECXPORT,DIRECSS

DIRECTIVE = *  ;( .=DIRUM )
   BIT DEBUG
   BPL +
   PHA
   LDA #<DIRECSG
   LDY #>DIRECSG
   JSR PUTS
   PLA
+  ASL
   TAY
   LDA DIRECECTORS+0,Y
   STA WORK+14
   LDA DIRECECTORS+1,Y
   STA WORK+15
   JSR +
   JMP PARSEND
+  JMP (WORK+14)
   DIRECSG = *
   .ASC "MUST PARSE A DIRECTIVE"
   .BYTE CHR,0

DIRECRG = *
   BIT ORIGINET
   BPL +
   LDA #ERRRIGINLREADYET
   JMP ERROR
+  LDA #0
   JSR PARSEXPRESSION
   CMP #CHR
   BEQ +
   JMP SYNTAXRROR
+  JSR EVALUATEXPRESSION
   BCC +
   LDA #ERROTESOLVEDXPR
   JMP ERROR
+  LDA IDAL+2
   ORA IDAL+3
   BEQ +
   LDA #ERRALUEOOARGE
   JMP ERROR
+  LDA IDAL+0
   LDY IDAL+1
   STA ADDRESS+0
   STY ADDRESS+1
   STA ADDRESSRIGIN+0
   STY ADDRESSRIGIN+1
   LDA #$FF
   STA ORIGINET
   BIT DEBUG
   BPL +
   LDA #<DIRECRGSG
   LDY #>DIRECRGSG
   JSR PUTS
   LDA IDAL+1
   JSR PUTHEX
   LDA IDAL+0
   JSR PUTHEX
   LDA #CHR
   JSR PUTCHAR
+  RTS
   DIRECRGSG = *
   .ASC "SETTING CODE ORIGIN TO $"
   .BYTE 0

DIRECFIZE .BUF 1
DIRECFHAR .BUF 1

DIRECB = *
   LDA #1
   BNE DIRECLN
DIRECW = *
   LDA #2
   BNE DIRECLN
DIRECT = *
   LDA #3
   BNE DIRECLN
DIRECL = *
   LDA #4
   DIRECLN = *
   STA DIRECFIZE
   BIT ORIGINET
   BMI DIRECFEXT
   LDA #ERRRIGINOTET
   JMP ERROR

   DIRECFEXT = *
   LDA #1
   JSR PARSEXPRESSION
   STA DIRECFHAR
   CPX #0
   BEQ +
   JSR DIRECFTRING
   JMP DIRECFONT
+  JSR EVALUATEXPRESSION
   BCS ++
   LDX DIRECFIZE
-  CPX #4
   BCS ++
   LDA IDAL,X
   BNE +
   INX
   BNE -
+  LDA #ERRALUEOOARGE
   JMP ERROR
+  LDA #1
   LDY #0
   STA DIRECFOUNT+0
   STY DIRECFOUNT+1
   JSR DIRECFUT

   DIRECFONT = *
   LDA DIRECFHAR
   CMP #","
   BEQ DIRECFEXT
   CMP #CHR
   BEQ +
   JMP SYNTAXRROR
+  RTS

DIRECFTROS .BUF 1

DIRECFTRING = *
   LDA #0
   STA DIRECFTROS
   STA IDYPE
   STA IDAL+1
   STA IDAL+2
   STA IDAL+3
-  LDX DIRECFTROS
   CPX STRINGEN
   BCC +
   RTS
+  LDA STRINGUF,X
   STA IDAL+0
   LDA #1
   LDY #0
   STA DIRECFOUNT+0
   STY DIRECFOUNT+1
   JSR DIRECFUT
   INC DIRECFTROS
   JMP -

DIRECFOUNT .BUF 2

DIRECFUT = *  ;(ADDRESS++, IDAL, IDYPE, DIRECFIZE, DIRECFOUNT--, EXPUF)
   LDA DIRECFOUNT+0
   ORA DIRECFOUNT+1
   BNE +
   RTS

   ;** DEBUG INFORMATION
+  BIT DEBUG
   BPL +++
   LDA #<DIRECFUTSG1
   LDY #>DIRECFUTSG1
   JSR PUTS
   LDA ADDRESS+1
   JSR PUTHEX
   LDA ADDRESS+0
   JSR PUTHEX
   LDA #<DIRECFUTSG2
   LDY #>DIRECFUTSG2
   JSR PUTS
   BIT IDYPE
   BPL +
   LDA #"?"
   JSR PUTCHAR
   JMP ++
+  LDX #IDAL
   JSR PUTNUM
+  LDA #CHR
   JSR PUTCHAR

   ;** HANDLE UNRESOLVED REFERENCE
+  BIT IDYPE
   BPL +
   LDX DIRECFIZE
   LDA #0
   JSR ADDEMORYOLE

   ;** HANDLE RESOLVED REFERENCE
+  LDX #3
-  LDA IDAL,X
   STA MEMUTALS,X
   DEX
   BPL -
   LDA DIRECFIZE
   LDX ADDRESS+0
   LDY ADDRESS+1
   JSR MEMUT
   ;** ADD RELOCATABLE REFERENCE
   LDA IDYPE
   BEQ +
   CMP #$04
   BCS +
   LDX ADDRESS+0
   LDY ADDRESS+1
   JSR RECORDELOCEF

   ;** GO ONTO NEXT PUT
+  CLC
   LDA ADDRESS+0
   ADC DIRECFIZE
   STA ADDRESS+0
   BCC +
   INC ADDRESS+1
   BNE +
   LDA #ERRDDRESSRAP
   JMP ERROR
+  LDA DIRECFOUNT+0
   BNE +
   DEC DIRECFOUNT+1
+  DEC DIRECFOUNT+0
   JMP DIRECFUT

DIRECFUTSG1 = *
   .ASC "DEFINE-PUT: ADDRESS=$"
   .BYTE 0
DIRECFUTSG2 = *
   .ASC ", VALUE="
   .BYTE 0

DIRECUF = *
   BIT ORIGINET
   BMI +
   LDA #ERRRIGINOTET
   JMP ERROR
+  LDA #0
   JSR PARSEXPRESSION
   CMP #CHR
   BEQ +
   JMP SYNTAXRROR
+  JSR EVALUATEXPRESSION
   BCC +
   LDA #ERROTESOLVEDXPR
   JMP ERROR
+  LDA IDAL+2
   ORA IDAL+3
   BEQ +
   LDA #ERRALUEOOARGE
   JMP ERROR
+  LDA IDAL+0
   LDY IDAL+1
   STA DIRECFOUNT+0
   STY DIRECFOUNT+1
+  LDA #0
   STA IDYPE
   STA IDAL+0
   STA IDAL+1
   STA IDAL+2
   STA IDAL+3
   LDA #1
   STA DIRECFIZE
   JSR DIRECFUT
   RTS

DIRECNCLUDE = *
DIRECF = *
DIRECLSIF = *
DIRECLSE = *
DIRECNDIF = *
DIRECACRO = *
DIRECNDMACRO = *
DIRECXPORT = *
   LDA #ERROTMPLEMENTED
   JMP ERROR
DIRECSS = *
   BIT ORIGINET
   BPL +
   LDA #ERRRIGINOTET
   JMP ERROR
+  NOP
   LDA #ERROTMPLEMENTED
   JMP ERROR

;======== ERROR HANDLER ========

ERRORODE      .BUF 1
ERROROS       .BUF 1
ERRORXITODE  = ACEXITATA+0    ;$FC8A09CB:EDITOR-REPOS
ERRORXITINE  = ACEXITATA+4
ERRORXITOL   = ACEXITATA+8
ERRORXITEPOS = ACEXITATA+12
ERRORXITILEP = ACEXITATA+13
ERRORXITESER = ACEXITATA+14
ERRORUF       = ACEXITATA+15

ERROREF = *
   JSR ERRORRERAMBLE
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JSR ERRORAT
   LDX #3
-  LDA EXPRCINE,X
   STA WORK+0,X
   LDA EXPRCILE,X
   STA WORK+4,X
   DEX
   BPL -
   LDA EXPRCOL
   LDX #WORK+0
   LDY #WORK+4
   JSR ERRORISPILE
   JMP ERRORN

ERRORRERAMBLE = *
   STA ERRORODE
   LDX #14
-  LDA ERRORXITEAD,X
   STA ERRORXITODE,X
   DEX
   BPL -
   LDA #0
   STA ERROROS
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR ERRORAT
   LDX #SOURCEINE
   LDY #FILETR
   LDA SOURCEOL
   JMP ERRORISPILE

ERROR = *
   JSR ERRORRERAMBLE
   ERRORN = *
   LDX ERROROS
   LDA #" "
   STA ERRORUF,X
   INC ERROROS
   LDA ERRORODE
   ASL
   TAX
   LDA ERRESC+1,X
   TAY
   LDA ERRESC+0,X
   JSR ERRORAT
   LDA ERRORODE
   CMP #ERRNRESDEFERENCES
   BNE +
   LDA #<SYMAME
   LDY #>SYMAME
   JSR ERRORAT
+  LDA #<ERRORUF
   LDY #>ERRORUF
   JSR EPUTS
   LDA #CHR
   LDX #STDERR
   JSR PUTC
   LDA #1
   LDX #0
   JMP EXIT

ERRISPIP  .BUF 1
ERRISPIOL .BUF 1
ERRISPIIN .BUF 1

ERRORISPILE = *  ;( .=ZPINEFF, .=COL, .=ZPILETR, ERROROS ) : ERROROS
   ;** USES NAME INSTEAD OF FILETR FOR NOW
   ;** PRODUCES OUTPUT OF THE FORM: ("FILENAME":1234:12)
   STA ERRISPIOL
   STX ERRISPIIN
   STY ERRISPIP
   LDX ERROROS
   LDA #"("
   STA ERRORUF,X
   INX
   LDA #CHRUOTE
   STA ERRORUF,X
   INX
   STX ERROROS
   LDA NAME+0
   LDY NAME+1
   JSR ERRORAT
   LDA #CHRUOTE
   STA ERRORUF,X
   INX
   LDA #":"
   STA ERRORUF,X
   INX
   STX ERROROS
   LDX ERRISPIIN
   JSR ERRORISPILEPNUM
   LDA #":"
   STA ERRORUF,X
   INX
   STX ERROROS
   LDA ERRISPIOL
   STA NUMBER+0
   LDA #0
   STA NUMBER+1
   STA NUMBER+2
   STA NUMBER+3
   LDX #NUMBER
   JSR ERRORISPILEPNUM
   LDA #")"
   STA ERRORUF,X
   INX
   STX ERROROS
   RTS

ERRORISPILEPNUM = *  ;( .=ZPOFF, ERROROS ) : .=ERROROS
   LDA #<PUTNUMUM
   LDY #>PUTNUMUM
   STA ZP+0
   STY ZP+1
   LDA #1
   JSR UTOA
   LDA #<PUTNUMUM
   LDY #>PUTNUMUM
   ;** FALL THROUGH

ERRORAT = *  ;( .=STR, ERROROS ) : .=ERROROS
   STA WORK+14
   STY WORK+15
   LDX ERROROS
   LDY #0
-  LDA (WORK+14),Y
   STA ERRORUF,X
   BEQ +
   INX
   INY
   BNE -
+  STX ERROROS
   RTS

ERRORXITEAD = *
   .BYTE $FC,$8A,$09,$CB,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$06,$00
ERRORSG1 = *
   .ASC "ERR "
   .BYTE 0
ERRORSG2 = *
   .ASC ", REF"
   .BYTE 0

ERRESC .WORD ERR00,ERR01,ERR02,ERR03,ERR04,ERR05,ERR06,ERR07,ERR08,ERR09
        .WORD ERR10,ERR11,ERR12,ERR13,ERR14,ERR15,ERR16,ERR17,ERR18,ERR19
        .WORD ERR20,ERR21,ERR22,ERR23,ERR24,ERR25,ERR26

ERR00 .ASC "K--NO ERROR"
      .BYTE 0
ERR01 .ASC "N IDENTIFIER TOKEN EXCEEDS 240 CHARS IN LENGTH"
      .BYTE 0
ERR02 .ASC " STRING LITERAL EXCEEDS 240 CHARS IN LENGTH"
      .BYTE 0
ERR03 .ASC "AN INTO A  BEFORE END OF STRING LITERAL"
      .BYTE 0
ERR04 .ASC "NVALID NUMERIC LITERAL"
      .BYTE 0
ERR05 .ASC "UMERIC LITERAL VALUE OVERFLOWS 32-BITS"
      .BYTE 0
ERR06 .ASC "YNTAX ERROR"
      .BYTE 0
ERR07 .ASC "TTEMPT TO PERFORM NUMERIC OPERATORS ON A STRING"
      .BYTE 0
ERR08 .ASC "XPRESSION HAS MORE THAN 17 OPERANDS"
      .BYTE 0
ERR09 .ASC "AN OUT OF MEMORY DURING COMPILATION PROCESS"
      .BYTE 0
ERR10 .ASC "TTEMPT TO REDEFINE A SYMBOL"
      .BYTE 0
ERR11 .ASC "TTEMPT TO ASSEMBLE CODE WITH CODE ORIGIN NOT SET"
      .BYTE 0
ERR12 .ASC "NTERNAL ERROR: ATTEMPT TO ASSIGN TO UNEXPECTED ID"
      .BYTE 0
ERR13 .ASC "ON-NUMERIC SYMBOL IN A NUMERIC EXPRESSION"
      .BYTE 0
ERR14 .ASC "XPECTING AN OPERATOR"
      .BYTE 0
ERR15 .ASC "XPECTING AN OPERAND"
      .BYTE 0
ERR16 .ASC "XPECTING A COMMAND"
      .BYTE 0
ERR17 .ASC "ALUE IS TOO LARGE OR NEGATIVE"
      .BYTE 0
ERR18 .ASC "RANCH OUT OF RANGE"
      .BYTE 0
ERR19 .ASC "EATURE IS NOT (YET) IMPLEMENTED"
      .BYTE 0
ERR20 .ASC "NSTRUCTION DOES NOT SUPPORT GIVEN ADDRESS MODE"
      .BYTE 0
ERR21 .ASC "DDRESS WRAPED AROUND 64 CODE ADDRESS SPACE"
      .BYTE 0
ERR22 .ASC "RROR TRYING TO WRITE OUTPUT OBJECT FILE"
      .BYTE 0
ERR23 .ASC "IRECTIVE REQUIRES RESOLVED EXPRESSION"
      .BYTE 0
ERR24 .ASC "ODE ORIGIN ALREADY SET; YOU CAN'T SET IT TWICE"
      .BYTE 0
ERR25 .ASC "NRESOLVED SYMBOL: "
      .BYTE 0
ERR26 .ASC "HUS ASSEMBLER DOESN'T ACCEPT .DOT COMMANDS, UDDY!"
      .BYTE 0

WPUTNUM = *
   LDA #STDOUT
   STA PUTNUMD
   JMP PUTNUMN
EPUTNUM = *
   LDA #STDERR
   JMP FPUTNUM
PUTNUM = *
   LDA #STDOUT
FPUTNUM = *
   STA PUTNUMD
   LDY #1
PUTNUMN = *
   LDA #<PUTNUMUM
   STA ZP+0
   LDA #>PUTNUMUM
   STA ZP+1
   TYA
   JSR UTOA
   LDX PUTNUMD
   JMP FPUTSP

PUTNUMD  .BUF 1
PUTNUMUM .BUF 11

PUTHEX = *  ;( .=VALUE )
   LDX #STDOUT
FPUTHEX = *  ;( .=VALUE, .=FD )
   STX PUTNUMD
   PHA
   LSR
   LSR
   LSR
   LSR
   TAX
   LDA PUTHEXHARS,X
   LDX PUTNUMD
   JSR PUTC
   PLA
   AND #$0F
   TAX
   LDA PUTHEXHARS,X
   LDX PUTNUMD
   JSR PUTC
   RTS
   PUTHEXHARS = *
   .ASC "0123456789ABCDEF"

CHECKTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

;======== UTILITY FUNCTIONS ========

INCONG = *  ;( .=ZPFFSET )
   INC 0,X
   BNE +
   INC 1,X
   BNE +
   INC 2,X
   BNE +
   INC 3,X
+  RTS

DECONG = *  ;( .=ZPFFSET )
   SEC
   LDA 0,X
   SBC #1
   STA 0,X
   INX
   LDY #3
-  LDA 0,X
   SBC #0
   STA 0,X
   INX
   DEY
   BNE -
   RTS

;======== INCLUDED FILES ========

.SEQ ASHELP.S

;======== BSS ========

BSS = *
SOURCEUF    = BSS+0                  ;( 256 BYTES)
STRINGUF    = SOURCEUF+256          ;( 256 BYTES)
SYMUF       = STRINGUF+256          ;( 256 BYTES)
SYMEXT      = SYMUF+0
SYMALUE     = SYMUF+4
SYMNRESPND = SYMUF+8
SYMYPE      = SYMUF+9
SYMLASS     = SYMUF+10
SYMAMEEN   = SYMUF+11
SYMAME      = SYMUF+12
SYMASH      = SYMUF+254
EXPABLE     = SYMUF+256            ;( 256 BYTES == 15 ENTRIES)
EXPOLEYPE  = EXPABLE+0
EXPENGTH    = EXPABLE+1
EXPNRESNT  = EXPABLE+2
EXPRCOL    = EXPABLE+3
EXPOLEDDR  = EXPABLE+4
EXPRCINE   = EXPABLE+8
EXPRCILE   = EXPABLE+12
EXPIELD     = EXPABLE+0
EXPP        = EXPIELD+0
EXPYPE      = EXPIELD+1
EXPIGN      = EXPIELD+2
EXPIO      = EXPIELD+3
EXPALUE     = EXPIELD+4
EXPEXTNRES = EXPIELD+8
EXPEXTPND  = EXPIELD+12
EXPESERVED  = EXPIELD+13
IDENTASHABLE = EXPABLE+256      ;(4096 BYTES == 1024 ENTRIES (REF:HABAG)
MEMTRABLE  = IDENTASHABLE+4096 ;( 256 BYTES == 64 ENTRIES)
MEMUF       = MEMTRABLE+256    ;( 256 BYTES)
WRITEAME    = MEMUF+256         ;(  20 BYTES)
TPAREEMAP   = WRITEAME+20       ;( 256 BYTES)
BSSND       = TPAREEMAP+256
