;*** CRC32A PROGRAM - BY RAIG RUCE

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:CRC32A"

JMP CRCAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $40

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

;===CRC32===
CRCRG = 2
CRCAME = 4
INUFEN = 6

CRCAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE CRCNOUGHRGS
   LDA ACERGC
   CMP #2
   BCS CRCNOUGHRGS

CRCSAGE = *
   LDA #<CRCSAGESG
   LDY #>CRCSAGESG
   JMP EPUTS

CRCSAGESG = *
   .ASC "SAGE: CRC32 FILE1 FILE2 ... FILE"
   .BYTE CHR
   .BYTE 0

CRCNOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<CRCNUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>CRCNUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA CRCRG
   STY CRCRG+1
-  JSR CHECKSTOP
   LDA CRCRG
   LDY CRCRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA CRCAME
   STY CRCAME+1
   ORA ZP+1
   BEQ CRCXIT
   JSR CRC32
   BCC +
   JSR CRCRROR
+  INC CRCRG
   BNE +
   INC CRCRG+1
+  JMP -

CRCXIT = *
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

CRCRROR = *
   LDA #<CRCRRORSG1
   LDY #>CRCRRORSG1
   JSR EPUTS
   LDA CRCAME
   LDY CRCAME+1
   JSR EPUTS
   LDA #<CRCRRORSG2
   LDY #>CRCRRORSG2
   JMP EPUTS

CRCRRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0

CRCRRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFTR = 8
BUFOUNT = 10
INFILE = 12

CRC32 = *
   ;** OPEN FILE
   LDA CRCAME
   LDY CRCAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   ;** ENCODE FILE
   JSR CRCODY
   ;** CLOSE FILE
   LDA INFILE
   JSR CLOSE
   RTS

;CRC32 VERSION 1.0 FOR THE -128 AND -64 BY RAIG RUCE 23-AY-92

CH = 13         ;(1)
CRCCCUM = 34   ;(4)

CRCOW  = $B7
CRCID1 = $1D
CRCID2 = $C1
CRCIGH = $04

CRCODY = *
   LDX #3
   LDA #0
-  STA CRCCCUM,X
   DEX
   BPL -
   STA BUFOUNT
   STA BUFOUNT+1

   ;***SCAN FILE

   NEXTHAR = *
   JSR GETYTE
   BCS CRCRINT
   STA CH
   LDX #8

   NEXTIT = *
   ASL CH
   ROL CRCCCUM+0
   ROL CRCCCUM+1
   ROL CRCCCUM+2
   ROL CRCCCUM+3
   BCC +
   LDA CRCCCUM+0 
   EOR #CRCOW
   STA CRCCCUM+0
   LDA CRCCCUM+1
   EOR #CRCID1
   STA CRCCCUM+1
   LDA CRCCCUM+2 
   EOR #CRCID2
   STA CRCCCUM+2
   LDA CRCCCUM+3 
   EOR #CRCIGH
   STA CRCCCUM+3
+  DEX
   BNE NEXTIT
   JMP NEXTHAR

   CRCRINT = *
   LDA #<RESSG1+9
   LDY #>RESSG1+9
   STA ZP+0
   STY ZP+1
   LDX #CRCCCUM
   LDA #10
   JSR UTOA
   LDA #" "
   STA RESSG1+19
   LDA #<RESSG1
   LDY #>RESSG1
   JSR PUTS
   LDA CRCAME
   LDY CRCAME+1
   JSR PUTS
   LDA #<RESSG2
   LDY #>RESSG2
   JSR PUTS
   CLC
   RTS

RESSG1 = *
   .ASC "CRC32A = 1234567890 FOR "
   .BYTE CHRUOTE,0
RESSG2 = *
   .BYTE CHRUOTE,CHR,0

GETYTE = *
   LDA BUFOUNT
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKSTOP
   LDA #<CRCNUF
   LDY #>CRCNUF
   STA ZP
   STY ZP+1
   STA BUFTR
   STY BUFTR+1
   LDA INUFEN
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT
   STY BUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

;===THE END===
CRCSS = *
CRCNUF  = CRCSS
