;*** GREP PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:GREP"

JMP GREPAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $40

CHR = $0D
CHRUOTE = $22
MAXINEEN = 2049

INVERSELAG .BUF 1
IGNOREASELAG .BUF 1
DISPLAYILENAMELAG .BUF 1
ANCHOREFTLAG .BUF 1
ANCHORIGHTLAG .BUF 1
STRINGEN .BUF 1

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

;===GREP===
GREPRG = 2
GREPAME = 4
INUFEN = 6
GREPTRING = 8

GREPAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA #0
   STA INVERSELAG
   STA IGNOREASELAG
   STA DISPLAYILENAMELAG
   STA ANCHOREFTLAG
   STA ANCHORIGHTLAG
   LDA ACERGC+1
   BNE GREPNOUGHRGS
   LDA ACERGC
   CMP #3
   BCS GREPNOUGHRGS

GREPSAGE = *
   LDA #<GREPSAGESG
   LDY #>GREPSAGESG
   JMP EPUTS

GREPSAGESG = *
   .ASC "USAGE: GREP [-[I][V]] [^]SUBSTR[$] FILES"
   .BYTE CHR,0

GREPNOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<GREPNUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>GREPNUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA GREPRG
   STY GREPRG+1
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE SUBSTRRG
   INC GREPRG
-  INY
   LDA (ZP),Y
   BEQ SUBSTRRG
   CMP #"I"
   BNE +
   LDA #$FF
   STA IGNOREASELAG
+  CMP #"V"
   BNE +
   LDA #$FF
   STA INVERSELAG
+  JMP -

   SUBSTRRG = *
   LDA GREPRG
   LDY #0
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA GREPTRING
   STY GREPTRING+1
   BIT IGNOREASELAG
   BPL +
   JSR FOLDTRING
+  JSR CHECKNCHORS
   INC GREPRG
   
   FIRSTRG = *
   LDA GREPRG
   LDY #0
   JSR GETARG
   LDA ZP
   ORA ZP+1
   BNE +
   JMP GREPSAGE
+  CLC
   LDA GREPRG
   ADC #1
   LDY #0
   JSR GETARG
   LDA ZP
   ORA ZP+1
   BEQ NEXTRG
   LDA #$FF
   STA DISPLAYILENAMELAG

   NEXTRG = *
   JSR CHECKSTOP
   LDA GREPRG
   LDY GREPRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA GREPAME
   STY GREPAME+1
   ORA ZP+1
   BEQ GREPXIT
   JSR GREP
   BCC +
   JSR GREPRROR
+  INC GREPRG
   BNE +
   INC GREPRG+1
+  JMP NEXTRG

GREPXIT = *
   RTS

FOLDTRING = *
   LDY #0
-  LDA (GREPTRING),Y
   BNE +
   RTS
+  CMP #""
   BCC +
   CMP #""+1
   BCS +
   SEC
   SBC #""-"A"
   STA (GREPTRING),Y
+  INY
   BNE -
   RTS

CHECKNCHORS = *
   LDY #0
   LDA (GREPTRING),Y
   CMP #"^"
   BNE +
   LDA #$FF
   STA ANCHOREFTLAG
   INC GREPTRING
   BNE +
   INC GREPTRING+1
+  LDY #255
-  INY
   LDA (GREPTRING),Y
   BNE -
   STY STRINGEN
   DEY
   CPY #255
   BEQ +
   LDA (GREPTRING),Y
   CMP #"$"
   BNE +
   LDA #$FF
   STA ANCHORIGHTLAG
   LDA #0
   STA (GREPTRING),Y
   STY STRINGEN
+  RTS

GREPRROR = *
   LDA #<GREPRRORSG1
   LDY #>GREPRRORSG1
   JSR EPUTS
   LDA GREPAME
   LDY GREPAME+1
   JSR EPUTS
   LDA #<GREPRRORSG2
   LDY #>GREPRRORSG2
   JMP EPUTS

GREPRRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0

GREPRRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFTR = 10
BUFOUNT = 12
INFILE = 14

GREP = *
   ;** OPEN FILE
   LDA GREPAME
   LDY GREPAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   ;** ENCODE FILE
   JSR GREPODY
   ;** CLOSE FILE
   LDA INFILE
   JSR CLOSE
   RTS

LINEEN = $40      ;(2)
LINETR = $42      ;(2)

GREPODY = *
   LDA #0
   STA BUFOUNT
   STA BUFOUNT+1
-  JSR GETLINE
   BCC +
   RTS
+  JSR CHECKINE
   BIT INVERSELAG
   BMI +
   BCC -
   JSR WRITEINE
   JMP -
+  BCS -
   JSR WRITEINE
   JMP -

LINEESET = $44   ;(2)
STRINGOS = $46   ;(1)

CHECKINE = *  ;() : .=NO_MATCH, .=MATCH
   BIT ANCHORIGHTLAG
   BPL CHECKUBSTR
   CLC
   LDA LINETR
   ADC LINEEN
   STA LINETR
   LDA LINETR+1
   ADC LINEEN+1
   STA LINETR+1
   SEC
   LDA LINETR
   SBC STRINGEN
   STA LINETR
   LDA LINETR+1
   SBC #0
   STA LINETR+1

   CHECKUBSTR = *
   LDA LINETR
   LDY LINETR+1
   STA LINEESET
   STY LINEESET+1
   INC LINEESET
   BNE +
   INC LINEESET+1
+  LDY #0
   STY STRINGOS

   CHECKHAR = *
+  LDY STRINGOS
   LDA (GREPTRING),Y
   BEQ ENDFTRING
   LDY #0
   CMP (LINETR),Y
   BNE MISMATCH
-  INC STRINGOS
   INC LINETR
   BNE +
   INC LINETR+1
+  JMP CHECKHAR

   MISMATCH = *
   LDY #0
   LDA (LINETR),Y
   BEQ ENDFINE
   BIT IGNOREASELAG
   BPL +
   CMP #""
   BCC +
   CMP #""+1
   BCS +
   SEC
   SBC #""-"A"
   LDY STRINGOS
   CMP (GREPTRING),Y
   BEQ -
+  LDA LINEESET
   LDY LINEESET+1
   STA LINETR
   STY LINETR+1
   JMP CHECKUBSTR

   ENDFINE = *
   CLC
   RTS

   ENDFTRING = *
   BIT ANCHOREFTLAG
   BMI +
   SEC
   RTS
+  LDA LINEESET
   BNE +
   DEC LINEESET+1
+  DEC LINEESET
   LDA LINEESET
   CMP #<GREPINE
   BNE ENDFINE
   LDA LINEESET+1
   CMP #>GREPINE
   BNE ENDFINE
   SEC
   RTS

WRITEINE = *
   LDA DISPLAYILENAMELAG
   BEQ +
   LDA GREPAME
   LDY GREPAME+1
   JSR PUTS
   LDA #":"
   JSR PUTCHAR
+  LDA #<GREPINE
   LDY #>GREPINE
   STA ZP
   STY ZP+1
   LDA LINEEN
   LDY LINEEN+1
   LDX #STDOUT
   JSR WRITE
   LDA #CHR
   JSR PUTCHAR
   RTS

GETLINE = *  ;() : LINEEN, LINETR
   ;** IGNORES CHARS BEYOND MAX LINE LEN, IGNORES LAST LINE NOT ENDING IN ,
   ;** LINE ENDS WITH \0
   LDA #0
   STA LINEEN
   STA LINEEN+1
   LDA #<GREPINE
   LDY #>GREPINE
   STA LINETR
   STY LINETR+1
-  JSR GETYTE
   BCC +
   RTS
+  CMP #CHR
   BNE +
   LDA #0
   LDY #0
   STA (LINETR),Y
   LDA #<GREPINE
   LDY #>GREPINE
   STA LINETR
   STY LINETR+1
   CLC
   RTS
+  LDX LINEEN+1
   CPX #>MAXINEEN
   BCS -
   LDY #0
   STA (LINETR),Y
   INC LINETR
   BNE +
   INC LINETR+1
+  INC LINEEN
   BNE +
   INC LINEEN+1
+  JMP -

GETYTE = *
   LDA BUFOUNT
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKSTOP
   LDA #<GREPNUF
   LDY #>GREPNUF
   STA ZP
   STY ZP+1
   STA BUFTR
   STY BUFTR+1
   LDA INUFEN
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT
   STY BUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

;===THE END===
GREPSS = *
GREPINE = GREPSS
GREPNUF  = GREPINE+MAXINEEN
