;*** FILE READER PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@:READ"

JMP CRCAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $40

CHR = $0D
CHR = $07
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

ITOAIN = LIBWORK       ;(4)
ITOACD = LIBWORK+4     ;(5)
ITOALAG = LIBWORK+9    ;(1)
ITOAUMBER .BUF 11
ITOA = *  ;( .=NUMPADDR ) : ITOAUMBER
   LDY #0
-  LDA 0,X
   STA ITOAIN,Y
   INX
   INY
   CPY #4
   BCC - 
   LDX #5
   LDA #0
-  STA ITOACD,X   ;ZEROS "ITOALAG" TOO
   DEX
   BPL -
   LDY #32
   SEI
   SED

   ITOAEXTIT = *
   ASL ITOAIN+0
   ROL ITOAIN+1
   ROL ITOAIN+2
   ROL ITOAIN+3
   LDX #4
-  LDA ITOACD,X
   ADC ITOACD,X
   STA ITOACD,X
   DEX
   BPL -
   DEY
   BNE ITOAEXTIT
   CLD
   CLI
   LDX #0
   LDY #0
-  LDA ITOACD,X
   JSR ITOAUTEX
   INX
   CPX #5
   BCC -
   LDA #0
   STA ITOAUMBER,Y
   RTS
   
   ITOAUTEX = *
   PHA
   LSR
   LSR
   LSR
   LSR
   JSR ITOAUTIGIT
   PLA
   AND #$0F

   ITOAUTIGIT = *
   CMP ITOALAG
   BNE +
   CPY #7
   BCS +
   LDA #$20
   BNE ITOAOKE
+  ORA #$30
   STA ITOALAG
   
   ITOAOKE = *
   STA ITOAUMBER,Y
   INY
   RTS

;===CRC32===
CRCRG = 2
CRCAME = 4
INUFEN = 6

CRCAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE CRCNOUGHRGS
   LDA ACERGC
   CMP #2
   BCS CRCNOUGHRGS

CRCSAGE = *
   LDA #<CRCSAGESG
   LDY #>CRCSAGESG
   JMP EPUTS

CRCSAGESG = *
   .ASC "USAGE: READ FILE1 FILE2 ... FILE"
   .BYTE CHR
   .BYTE 0

CRCNOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<CRCNUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>CRCNUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA CRCRG
   STY CRCRG+1
-  JSR STOPKEY
   BCS CRCTOPPED
   LDA CRCRG
   LDY CRCRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA CRCAME
   STY CRCAME+1
   ORA ZP+1
   BEQ CRCXIT
   JSR DOEAD
   BCC +
   JSR CRCRROR
+  INC CRCRG
   BNE +
   INC CRCRG+1
+  JMP -

CRCXIT = *
   RTS

CRCTOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   RTS
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

CRCRROR = *
   LDA #<CRCRRORSG1
   LDY #>CRCRRORSG1
   JSR EPUTS
   LDA CRCAME
   LDY CRCAME+1
   JSR EPUTS
   LDA #<CRCRRORSG2
   LDY #>CRCRRORSG2
   JMP EPUTS

CRCRRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0

CRCRRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFTR = 8
BUFOUNT = 10
INFILE = 12

DOEAD = *
   ;** OPEN FILE
   LDA CRCAME
   LDY CRCAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   LDA #<READTARTSG
   LDY #>READTARTSG
   JSR EPUTS
   ;** READ FILE
   JSR READODY
   ;** CLOSE FILE
   LDA #<READINISHSG
   LDY #>READINISHSG
   JSR EPUTS
   LDA INFILE
   JSR CLOSE
   RTS

READTARTSG = *
   .ASC "START"
   .BYTE CHR,CHR,0

READINISHSG = *
   .BYTE CHR
   .ASC "FINISHED"
   .BYTE CHR,0

READODY = *
   LDA #<CRCNUF
   LDY #>CRCNUF
   STA ZP
   STY ZP+1
   LDA INUFEN+0
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   JMP READODY
+  SEC
   RTS

;===THE END===
CRCSS = *
CRCNUF  = CRCSS
