;*** SORT PROGRAM - BY RAIG RUCE, STARTED 13-UN-93

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:SORT"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $40

CHR = $0D
CHRUOTE = $22
MAXINEEN = 2049
TRUE = $FF
FALSE = $00

REVERSELAG     .BUF 1
IGNOREASELAG  .BUF 1
KEYOSITION     .BUF 1

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   RTS

;===MAIN===
ARG = 2
NAME = 4
STRING = 8

MAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA #0
   STA REVERSELAG
   STA IGNOREASELAG
   LDA #1
   STA KEYOSITION
   LDA ACERGC+1
   BNE ENOUGHRGS
   LDA ACERGC
   CMP #2
   BCS ENOUGHRGS

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JMP EPUTS

USAGESG = *
   .ASC "USAGE: SORT [-[I][V]] [+COLUMN] FILE ..."
   .BYTE CHR,0

ENOUGHRGS = *
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA ARG+0
   STY ARG+1
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE KEYRG
   INC ARG+0
-  INY
   LDA (ZP),Y
   BEQ KEYRG
   CMP #"I"
   BNE +
   LDA #TRUE
   STA IGNOREASELAG
+  CMP #"V"
   BNE +
   LDA #TRUE
   STA REVERSELAG
+  JMP -

   KEYRG = *
   LDA ARG
   LDY #0
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"+"
   BNE FILERG
   JSR GETEYOSITION
   INC ARG

   FILERG = *
   JSR SORTNIT
-  JSR STOPKEY
   BCS STOPPED
   LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   ORA ZP+1
   BEQ MAINXIT
   JSR SORTEAD
   BCC +
   JSR ERROR
+  INC ARG+0
   BNE +
   INC ARG+1
+  JMP -

MAINXIT = *
   JSR SORTEAL
   JSR SORTRINT
   JSR SORTLEAN
   RTS

KEYIGIT = $71

GETEYOSITION = *
   LDA #0
   STA KEYOSITION
   INY
-  LDA (ZP),Y
   CMP #"0"
   BCC +
   CMP #"9"+1
   BCS +
   AND #$0F
   STA KEYIGIT
   LDA KEYOSITION
   ASL
   ASL
   CLC
   ADC KEYOSITION
   ASL
   CLC
   ADC KEYIGIT
   STA KEYOSITION
   INY
   BNE -
+  RTS

STOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

ERROR = *
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JMP EPUTS
   ERRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0
   ERRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFTR = 10   ;(1)
BUFOUNT = 12 ;(1)
INFILE = 14   ;(1)

SORTEAD = *
   ;** OPEN FILE
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   JSR READODY
   LDA INFILE
   JSR CLOSE
   RTS

;===SORT ROUTINES===

SORTHEAD = 30  ;(4)
SORT    = 34  ;(4)
SORT    = 38  ;(4)
HEADER   = 42  ;(5)

SORTNIT = *
   LDA #"S"
   JSR ECHOTATUS
   JSR MALLOCNIT
   LDA KEYOSITION
   CMP #1
   BCC +
   SBC #1
+  STA KEYOSITION
   LDX #3
   LDA #ACEEMULL
-  STA SORTHEAD,X
   DEX
   BPL -
   RTS

READODY = *
   LDA #"R"
   JSR ECHOTATUS
   LDA #0
   STA BUFOUNT
-  JSR GETLINE
   BCS +
   JSR POSITIONINE
   JSR STORELINE
   BCS +
   LDA #"."
   JSR ECHOTATUS
   JMP -
+  RTS

SORTEAL = *
   LDA REVERSELAG
   BMI +
   LDA #"V"
   JSR ECHOTATUS
   JSR REVERSEILE
+  RTS

SORTRINT = *
   LDA #"W"
   JSR ECHOTATUS
   LDA #13
   JSR ECHOTATUS
   JSR WRITEFILE
   RTS

SORTLEAN = *
   ;LDA #"F"
   ;JSR ECHOTATUS
   ;JSR FREEFILE
   ;LDA #13
   ;JSR ECHOTATUS
   RTS

;*** FETCHLINE( SORT=INETR, .=AM0BUF )

FETCHLINE = *
   STA ZP+0
   STY ZP+1
   LDX #3
-  LDA SORT,X
   STA MP,X
   DEX
   BPL -
   LDX #HEADER
   LDY #5
   JSR ZPLOAD
   LDA HEADER+4
   LDY #0
   JMP FETCH

;*** SORTCMP( SORTLINE, CMPLINE ) : .=SORTLINE >= CMPLINE

SORTCMP = *
   LDX #0
   CLC
   LDA KEYOSITION
   ADC #6
   CMP SORTBUFLEN
   BCC +
   INX
+  CMP CMPBUFLEN
   BCC +
   INX
   INX
+  TXA
   BEQ DOOMPARE
   CMP #2
   RTS

   DOOMPARE = *
   BIT IGNOREASELAG
   BMI DOASELESSOMPARE
   LDY KEYOSITION
-  LDA SORTLINE,Y
   CMP CMPLINE,Y
   BNE +
   CMP #0
   BEQ +
   INY
   BNE -
+  RTS

   CASELESSHAR = $72

   DOASELESSOMPARE = *
   LDY KEYOSITION
-  LDA SORTLINE,Y
   JSR LOWCASE
   PHA
   LDA CMPLINE,Y
   JSR LOWCASE
   STA CASELESSHAR
   PLA
   CMP CASELESSHAR
   BNE +
   CMP #0
   BEQ +
   INY
   BNE -
+  RTS

LOWCASE = *
   CMP #""
   BCC +
   CMP #""+1
   BCS +
   AND #$7F
+  RTS

;*** POSITIONINE( SORTLINE ) : SORT=PREV, SORT=NEXT

POSITIONINE = *
   LDX #3
-  LDA #ACEEMULL
   STA SORT,X
   LDA SORTHEAD,X
   STA SORT,X
   DEX
   BPL -

   POSITIONEARCH = *
   LDA SORT+3
   CMP #ACEEMULL
   BEQ POSITIONXIT
   LDA #<CMPBUF
   LDY #>CMPBUF
   JSR FETCHLINE
   JSR SORTCMP
   BCS POSITIONXIT    ;** CONTROLS SORT ORDER
   LDX #3
-  LDA SORT,X
   STA SORT,X
   LDA CMPBUF,X
   STA SORT,X
   DEX
   BPL -
   BMI POSITIONEARCH

   POSITIONXIT = *
   RTS

;*** STORELINE( SORTLINE )    BETWEEN SORT AND SORT

STORELINE = *
   LDA SORTBUFLEN
   LDY #0
   JSR MALLOC
   BCC +
   RTS
+  LDX #3
-  LDA SORT,X
   STA SORTBUF,X
   DEX
   BPL -
   LDA #<SORTBUF
   LDY #>SORTBUF
   STA ZP+0
   STY ZP+1
   LDA SORTBUFLEN
   LDY #0
   JSR STASH
   LDA SORT+3
   CMP #ACEEMULL
   BEQ STORELINEIRST
   LDX #3
-  LDA MP,X
   LDY SORT,X
   STA SORT,X
   STY MP,X
   DEX
   BPL -
   LDX #SORT
   LDY #4
   JSR ZPSTORE
   CLC
   RTS

   STORELINEIRST = *
   LDX #3
-  LDA MP,X
   STA SORTHEAD,X
   DEX
   BPL -
   CLC
   RTS

;*** WRITEFILE()

WRITEFILE = *
   LDX #3
-  LDA SORTHEAD,X
   STA SORT,X
   DEX
   BPL -

   WRITEINE = *
   LDA SORT+3
   CMP #ACEEMULL
   BEQ WRITEXIT
   LDA #<SORTBUF
   LDY #>SORTBUF
   JSR FETCHLINE
   JSR PUTLINE
   LDX #3
-  LDA SORTBUF,X
   STA SORT,X
   DEX
   BPL -
   JMP WRITEINE

   WRITEXIT = *
   RTS

;*** REVERSEIST()

REVERSEILE = *
   LDX #3
-  LDA SORTHEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA SORTHEAD,X
   DEX
   BPL -

   REVERSEINE = *
   LDA MP+3
   CMP #ACEEMULL
   BEQ REVERSEXIT
   LDX #SORT
   LDY #4
   JSR ZPLOAD
   LDX #SORTHEAD
   LDY #4
   JSR ZPSTORE
   LDX #3
-  LDA MP,X
   STA SORTHEAD,X
   LDA SORT,X
   STA MP,X
   DEX
   BPL -
   BMI REVERSEINE

   REVERSEXIT = *
   RTS

;*** FREEFILE()

FREEFILE = *
   LDX #3
-  LDA SORTHEAD,X
   STA MP,X
   DEX
   BPL -

   FREEINE = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   RTS
+  LDX #HEADER
   LDY #5
   JSR ZPLOAD
   LDA HEADER+4
   LDY #0
   JSR FREE
   LDX #3
-  LDA HEADER,X
   STA MP,X
   DEX
   BPL -
   JMP FREEINE

ECHOTATUS = *
   LDX #STDERR
   JMP PUTC

;===DYNAMIC MEMORY ROUTINES===

MALLOCORK = $60

MALLOCEAD   .BUF 4
TPAREEIRST .BUF 1
TPAREEIN   .BUF 1
TPAREEAGES .BUF 1
TPAREATART .BUF 1
TPAREAND   .BUF 1

;*** MALLOCNIT()

MALLOCNIT = *
   LDA #ACEEMULL
   STA MALLOCEAD+3
   LDX #0
   LDA #$FF
-  STA TPAREEMAP,X
   INX
   BNE -
   LDX #>BSSND
   LDA #<BSSND
   BEQ +
   INX
+  STX TPAREEIRST
   STX TPAREATART
   LDX ACEEMOP+1
   STX MALLOCORK
   STX TPAREAND
   TXA
   SEC
   SBC TPAREEIRST
   BCS +
   LDA #0
+  STA TPAREEAGES
   CLC
   ADC #1
   STA TPAREEIN
   LDX TPAREEIRST
   CPX MALLOCORK
   BCS +
   LDA #$00
-  STA TPAREEMAP,X
   INX
   CPX MALLOCORK
   BCC -
+  RTS

LIBAGES .BUF 1

LIBAGELLOC = *  ;( .=PAGES ) : [MP]
   STA LIBAGES
   LDX #$00
   LDY #ACEEMNTERNAL-1
   JSR PAGEALLOC
   BCS +
   RTS
+  JSR TPAAGELLOC
   BCS +
   RTS
+  LDA LIBAGES
   LDX #ACEEMNTERNAL
   LDY #$FF
   JSR PAGEALLOC
   BCS +
   RTS
+  LDA #<NOMEMSG
   LDY #>NOMEMSG
   JSR EPUTS
   LDA #1
   JMP EXIT

   NOMEMSG = *
   .BYTE CHR
   .ASC "NSUFFICIENT MEMORY, ABORTING."
   .BYTE CHR,0

NEWMAX   .BUF 1

TPAAGELLOC = *  ;( LIBAGES ) : [MP]
   LDA LIBAGES
   CMP TPAREEIN
   BCS TPAREEMAPULL
   ;** FIRST FREE
   LDX TPAREEIRST
   LDA TPAREEMAP,X
   BEQ ++
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE -
   STX TPAREEIRST
   JMP ++
   TPAREEMAPULL = *
   LDA LIBAGES
   CMP TPAREEIN
   BCS +
   STA TPAREEIN
+  SEC
   RTS

   ;** SEARCH
+  DEX
-  LDY LIBAGES
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE --
   DEY
   BNE -

   ;** ALLOCATE
   STX NEWMAX
   LDY LIBAGES
   LDA #$41
-  STA TPAREEMAP,X
   DEX
   DEY
   BNE -
   INX
   CPX TPAREEIRST
   BNE +
   LDY NEWMAX
   INY
   STY TPAREEIRST
+  SEC
   LDA TPAREEAGES
   SBC LIBAGES
   STA TPAREEAGES
   LDA #0
   LDY #ACEEMNTERNAL
   STA MP+0
   STX MP+1
   STA MP+2
   STY MP+3
   CLC
   RTS

MALLOCENAVE .BUF 3

MALLOC = *
   STA MALLOCENAVE+0
   STY MALLOCENAVE+1
   JSR LIBALLOC
   BCS +
   RTS
+  LDX MALLOCENAVE+1
   LDA MALLOCENAVE+0
   BEQ +
   INX
+  TXA
   CPX #>1024
   BCS +
   LDX #>1024
+  TXA
   STA MALLOCENAVE+2
   JSR LIBAGELLOC
   BCC +
   RTS
+  LDA #0
   LDY MALLOCENAVE+2
   JSR FREE
   LDA MALLOCENAVE+0
   LDY MALLOCENAVE+1
   JMP MALLOC

;*** MALLOC( .=YTES ) : [MP]=AROINTER

MALLOCEMEXTTR = MALLOCORK+0 ;(4)
MALLOCEMENGTH  = MALLOCORK+4 ;(2)
MALLOCENGTH     = MALLOCORK+6 ;(2)
MALLOC          = MALLOCORK+8 ;(4)

LIBALLOC = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA MALLOCENGTH
   STY MALLOCENGTH+1
   LDX #3
-  LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA MALLOC,X
   DEX
   BPL -

   MALLOCOOK = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +

   MALLOCRRORXIT = *
   LDA #ACEEMULL
   STA MP+3
   LDA #ACERRNSUFFICIENTEMORY
   STA ERRNO
   SEC
   RTS

+  LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BCS MALLOCOTLOCK
   LDX #3
-  LDA MP,X
   STA MALLOC,X
   LDA MALLOCEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   JMP MALLOCOOK

   MALLOCOTLOCK = *
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   BNE +
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BEQ MALLOCAKEHOLELOCK
+  SEC
   LDA MALLOCEMENGTH
   SBC MALLOCENGTH
   STA MALLOCEMENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   STA MALLOCEMENGTH+1
   LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   LDA MP+0
   ADC MALLOCEMENGTH
   STA MP+0
   LDA MP+1
   ADC MALLOCEMENGTH+1
   STA MP+1
   CLC
   RTS

   MALLOCAKEHOLELOCK = *
   LDA MALLOC+3
   CMP #ACEEMULL
   BNE +
   LDX #3
-  LDA MALLOCEMEXTTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   CLC
   RTS
+  LDX #3
-  LDA MP,X
   LDY MALLOC,X
   STA MALLOC,X
   STY MP,X
   DEX
   BPL -
   LDX #MALLOCEMEXTTR
   LDY #4
   JSR ZPSTORE
   LDX #3
-  LDA MALLOC,X
   STA MP,X
   DEX
   BPL -
   CLC
   RTS

;*** FREE( [MP]=AROINTER, .=ENGTH )  ALTERS [MP]

FREEEMEXTTR = MALLOCORK+0  ;(4)
FREEEMENGTH  = MALLOCORK+4  ;(2)
FREEENGTH     = MALLOCORK+6  ;(2)
FREEEWTR     = MALLOCORK+8  ;(4)
FREE          = MALLOCORK+12 ;(4)

FREE = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA FREEENGTH+0
   STY FREEENGTH+1
   LDX #3
-  LDA MP,X
   STA FREEEWTR,X
   LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA FREE,X
   DEX
   BPL -

   FREEEARCHOOP = *
   LDA MP+3
   CMP #ACEEMULL
   BEQ FREEOALESCEANDEW
   LDA MP+0
   CMP FREEEWTR+0
   LDA MP+1
   SBC FREEEWTR+1
   LDA MP+2
   SBC FREEEWTR+2
   LDA MP+3
   SBC FREEEWTR+3
   BCS FREEOALESCEANDEW
+  LDX #FREEEMEXTTR
   LDY #4
   JSR ZPLOAD
   LDX #3
-  LDA MP,X
   STA FREE,X
   LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   BMI FREEEARCHOOP

   FREEOALESCEANDEW = *
   LDX #3
-  LDA FREE,X
   STA MP,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   ;** PREV IS HEAD
   LDX #3
-  LDA MALLOCEAD,X
   STA FREEEMEXTTR,X
   LDA FREEEWTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1
   JMP FREEOALESCEEWND

   ;** PREV IS REAL
+  LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MP+3
   CMP FREEEWTR+3
   BNE +
   LDA MP+2
   CMP FREEEWTR+2
   BNE +
   CLC
   LDA MP+0
   ADC FREEEMENGTH
   TAX
   LDA MP+1
   ADC FREEEMENGTH+1
   CMP FREEEWTR+1
   BNE +
   CPX FREEEWTR
   BNE +
   ;** PREV DOES COALESCE
   CLC
   LDA FREEEMENGTH
   ADC FREEENGTH
   STA FREEEMENGTH
   LDA FREEEMENGTH+1
   ADC FREEENGTH+1
   STA FREEEMENGTH+1
   LDX #3
-  LDA FREE,X
   STA FREEEWTR,X
   DEX
   BPL -
   BMI FREEOALESCEEWND

   ;** PREV DOES NOT COALESCE
+  LDX #FREEEWTR
   LDY #4
   JSR ZPSTORE
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1

   FREEOALESCEEWND = *
   LDA FREEEWTR+3
   CMP FREEEMEXTTR+3
   BNE +
   LDA FREEEWTR+2
   CMP FREEEMEXTTR+2
   BNE +
   CLC
   LDA FREEEWTR
   ADC FREEEMENGTH
   TAX
   LDA FREEEWTR+1
   ADC FREEEMENGTH+1
   CMP FREEEMEXTTR+1
   BNE +
   CPX FREEEMEXTTR
   BNE +

   ;** NEW AND NEXT COALESCE
   LDX #3
-  LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   LDA FREEEMENGTH+1
   PHA
   LDA FREEEMENGTH+0
   PHA
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   CLC
   PLA
   ADC FREEEMENGTH+0
   STA FREEEMENGTH+0
   PLA
   ADC FREEEMENGTH+1
   STA FREEEMENGTH+1

+  LDX #3
-  LDA FREEEWTR,X
   STA MP,X
   DEX
   BPL -
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   RTS

;=== LINE / ROUTINES ===

YSAVE = $70

GETLINE = *  ;( INFILE ) : SORTLINE, .=EOF
   LDY #0
-  STY YSAVE
   JSR GETYTE
   LDY YSAVE
   BCS +
   STA SORTLINE,Y
   INY
   CPY #240
   BCS GETLINEXIT
   CMP #13
   BNE -
   DEY

   GETLINEXIT = *
   LDA #0
   STA SORTLINE,Y
   CLC
   TYA
   ADC #6
   STA SORTBUFLEN
   CLC
+  RTS

PUTLINE = *  ;( SORTBUF )
   JSR STOPKEY
   BCC +
   JSR STOPPED
+  LDY SORTBUFLEN
   LDA #13
   STA SORTBUF-1,Y
   LDA #<SORTLINE
   LDY #>SORTLINE
   STA ZP+0
   STY ZP+1
   SEC
   LDA SORTBUFLEN
   SBC #5
   LDY #0
   LDX #STDOUT
   JSR WRITE
   LDY SORTBUFLEN
   LDA #0
   STA SORTBUF-1,Y
   RTS

GETYTE = *
   LDA BUFOUNT
   BEQ GETYTEILLUF
   LDY BUFTR
   LDA INUF,Y
   INC BUFTR
   DEC BUFOUNT
   CLC
   RTS

GETYTEILLUF = *
   JSR STOPKEY
   BCC +
   JSR STOPPED
+  LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   LDA #254
   LDY #0
   STY BUFTR
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT
   JMP GETYTE
+  SEC
   RTS

;===BSS===

BSS        = *
SORTBUF    = BSS+0
SORTBUFLEN = SORTBUF+4
SORTLINE   = SORTBUF+5
CMPBUF     = SORTBUF+256
CMPBUFLEN  = CMPBUF+4
CMPLINE    = CMPBUF+5
INUF      = CMPBUF+256
TPAREEMAP = INUF+256
BSSND     = TPAREEMAP+256
