;*** WORD COUNTER PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:WC"

JMP WCAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   STX XSAVE
   STY YSAVE
   LDX #STDOUT
   JSR PUTC
   LDX XSAVE
   LDY YSAVE
   RTS
   XSAVE .BUF 1
   YSAVE .BUF 1

PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

;===WORD COUNT===
WCRG = 2
WCAME = 4
INUFEN = 6
FILES = $50

WCAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE WCNOUGHRGS
   LDA ACERGC
   CMP #2
   BCS WCNOUGHRGS

WCSAGE = *
   LDA #<WCSAGESG
   LDY #>WCSAGESG
   JMP EPUTS

WCSAGESG = *
   .ASC "SAGE: WC FILE1 FILE2 ... FILE"
   .BYTE CHR,0

WCNOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<WCNUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>WCNUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA WCRG
   STY WCRG+1
   STY FILES
   JSR TOTNIT
-  JSR CHECKSTOP
   LDA WCRG
   LDY WCRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA WCAME
   STY WCAME+1
   ORA ZP+1
   BEQ WCXIT
   JSR WCILE
   BCS +
   LDA FILES
   BMI +
   INC FILES
+  BCC +
   JSR WCRROR
+  INC WCRG
   BNE +
   INC WCRG+1
+  JMP -

WCXIT = *
   LDA FILES
   CMP #2
   BCC +
   JSR REPORTOTAL
+  RTS

WCRROR = *
   LDA #<WCRRORSG1
   LDY #>WCRRORSG1
   JSR EPUTS
   LDA WCAME
   LDY WCAME+1
   JSR EPUTS
   LDA #<WCRRORSG2
   LDY #>WCRRORSG2
   JMP EPUTS

WCRRORSG1 = *
   .ASC "RROR READING FILE "
   .BYTE CHRUOTE,0

WCRRORSG2 = *
   .BYTE CHRUOTE,CHR,0

BUFOUNT = 10
INFILE = 12

WCILE = *
   ;** OPEN FILE
   LDA WCAME
   LDY WCAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR FASTOPEN
   BCC +
   RTS
+  STA INFILE
   ;** COUNT FILE
   JSR WCNIT
   JSR WCODY
   ;** CLOSE FILE
   LDA INFILE
   JSR FASTCLOSE
   JSR WCEPORT
   JSR ADDOOTAL
   RTS

WCODY = *
-  JSR CHECKSTOP
   LDA #<WCNUF
   LDY #>WCNUF
   STA ZP+0
   STY ZP+1
   LDA #254
   LDY #0
   LDX INFILE
   JSR FASTREAD
   STA BUFOUNT
   STY BUFOUNT+1
   BEQ +
   JSR WCCANUFFER
   JMP -
+  RTS

WCNORD = $4C ;(1)
WCINES = $40  ;(3)
WCORDS = $44  ;(3)
WCYTES = $48  ;(3)
TOTINES = $20  ;(3)
TOTORDS = $24  ;(3)
TOTYTES = $28  ;(3)

WCNIT = *
   LDA #0
   LDX #11
-  STA WCINES,X
   DEX
   BPL -
   STA WCNORD
   RTS

TOTNIT = *
   LDA #0
   LDX #11
-  STA TOTINES,X
   DEX
   BPL -
   RTS

WCCANUFFER = *
   LDY #0
   CPY BUFOUNT
   BNE +
   RTS
+  LDX WCNORD
-  LDA WCNUF,Y
   CMP #CHR
   BNE +
   INC WCINES
   BNE +
   INC WCINES+1
   BNE +
   INC WCINES+2 
   BNE +
   INC WCINES+3
+  CMP #33
   BCS ISETTER
   CMP #" "
   BEQ ISELIMITER
   CMP #CHR
   BEQ ISELIMITER
   CMP #9
   BEQ ISELIMITER

   ISETTER = *
   CPX #1
   BEQ SCANONT
   LDX #1
   INC WCORDS
   BNE SCANONT
   INC WCORDS+1
   BNE SCANONT
   INC WCORDS+2
   BNE SCANONT
   INC WCORDS+3
   JMP SCANONT

   ISELIMITER = *
   LDX #0

   SCANONT = *
   INY
   CPY BUFOUNT
   BCC -
   CLC
   LDA WCYTES
   ADC BUFOUNT
   STA WCYTES
   BCC +
   INC WCYTES+1
   BNE +
   INC WCYTES+2
   BNE +
   INC WCYTES+3
+  STX WCNORD
   RTS

WCEPORT = *
   LDX #WCINES
   LDA #6
   JSR PUTNUM
   LDX #WCORDS
   LDA #6
   JSR PUTNUM
   LDX #WCYTES
   LDA #7
   JSR PUTNUM
   LDA WCAME
   LDY WCAME+1
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   RTS

PUTNUM = *
   LDY #<NUMBUF
   STY ZP+0
   LDY #>NUMBUF
   STY ZP+1
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   JSR PUTS
   LDA #" "
   JSR PUTCHAR
   RTS

ADDOOTAL = *
   CLC
   LDX #0
-  LDA TOTINES,X
   ADC WCINES,X
   STA TOTINES,X
   INX
   TXA
   AND #$03
   BNE -
   CLC
   LDX #0
-  LDA TOTORDS,X
   ADC WCORDS,X
   STA TOTORDS,X
   INX
   TXA
   AND #$03
   BNE -
   CLC
   LDX #0
-  LDA TOTYTES,X
   ADC WCYTES,X
   STA TOTYTES,X
   INX
   TXA
   AND #$03
   BNE -
   RTS

REPORTOTAL = *
   LDA #<TOTALSG
   LDY #>TOTALSG
   STA WCAME
   STY WCAME+1
   LDX #11
-  LDA TOTINES,X
   STA WCINES,X
   DEX
   BPL -
   JSR WCEPORT
   RTS
   TOTALSG = *
   .ASC "<TOTAL>"
   .BYTE 0

;===THE END===
WCSS = *
NUMBUF = WCSS
WCNUF = NUMBUF+12
