;*** WRAP PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:WRAP"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

WORK1 = $02 ;(16)
WORK2 = $12 ;(16)
WORK3 = $22 ;(14)

CHR = $0D
CHRAB = $09
CHRUOTE = $22

;SCREEN

SCROPDDR      = $30 ;(2)
SCRINEDDR     = $32 ;(2)
CUROW          = $34 ;(1)
CUROL          = $35 ;(1)
SCROWS         = $36 ;(1)
SCROLS         = $37 ;(1)
SCROWNC       = $38 ;(2)
CUREFTARGIN   = $3A ;(1)

;DOCUMENT

LINETR         = $40 ;(4)
LINEUM         = $44 ;(4)
TOSINETR      = $48 ;(4)
TOPINETR      = $4C ;(4)
BOTINETR      = $50 ;(4)
LINEOUNT       = $54 ;(4)
FILEENGTH      = $58 ;(4)
TARGETEN       = $5C ;(1)
WRAPLAG        = $5D ;(1) ;128=WRAP,64=SHOW

;MANAGEMENT

MODIFIED        = $3B ;(1) ;$00=NO, $FF=MODIFIED
MODELAGS       = $3C ;(1) ;$80=INSERT, $40=INDENT
STATUSPDATE    = $3D ;(1) ;128=LINE,64=COL,32=MOD,16=INS,8=BYT,4=FRE,2=NM,1=MSG
MARKEDINETR   .BUF 4 ;(4)
MARKEDINEUM   .BUF 4 ;(4)
MARKEDOL       .BUF 4 ;(1)

;LINE FORMAT

HEADEXTTR     = $70 ;(4)
HEADREVTR     = $74 ;(4)
HEADINEEN     = $78 ;(1)
HEADNDENT      = $79 ;(1)
HEADLAGS       = $7A ;(1) ;$80=CONNECTED, $40=NULLINE
HEADENGTH      = $0B

;KILL BUFFER

BUFFEROPTR    .BUF 4 ;(4)
BUFFEROTTR    .BUF 4 ;(4)
BUFFERINEOUNT .BUF 4 ;(4)

;DOCUMENT BUFFERS

;=== MAIN ===

MAIN = *
   JSR MAINNIT
   LDA #1
   LDY #0
   JSR GETARG
   JSR LOADILE
   RTS

MAINNIT = *
   LDA #$80
   STA WRAPLAG
   LDA #75
   STA TARGETEN
   RTS

;*** LOAD FILE: USES WORK2 ***

LOADEAD  = WORK2+0
LOADAIL  = WORK2+4
LOADINES = WORK2+8
LOADYTES = WORK2+12
LOADCB      = WORK3+0
LOADINECAN = WORK3+1
LOADINEEN  = WORK3+2
LOADUFOUNT = WORK3+3
LOADUFTR   = WORK3+4

LOADILE = *  ;( (ZP)=NAME ) : [W2]=HEAD, [W2]=TAIL, [W2]=LINES, [W2]=BYTES
   JSR SAVEORK3
   JSR LOADNIT
   LDA #"R"
   JSR OPEN
   STA LOADCB
-  JSR LOADINE
   BCS +
   JSR LOADINERAP
   JSR LOADINETORE
   JSR LOADINEVERFLOW
   JMP -
+  LDA LOADINEEN
   BEQ +
   JSR LOADINERAP
   LDA #$00
   STA LINELAGS
   JSR LOADINETORE
+  LDA LOADCB
   JSR CLOSE
   JSR RESTOREORK3
   RTS

LOADNIT = *
   LDA #0
   LDX #16+14-1
-  STA LOADEAD,X
   DEX
   BPL -
   RTS

LOADINE = *  ;( ) : .=END
   ;TAB EXPANSION WILL GO INTO THIS ROUTINE
   LDX LOADUFTR
   LDY LOADINEEN

   LOADEXTYTE = *
   LDA LOADUFOUNT
   BNE ++
   STY LOADINEEN
   JSR LOADUF
   BCC +
   RTS
+  LDY LOADINEEN
   LDX LOADUFTR
+  NOP

-  LDA FILEBUF,X
   STA LINE,Y
   INX
   INY
   CMP #CHR
   BEQ ++
   CPY TARGETEN
   BEQ +  ;DETERMINES IF S WILL GO BEYOND LEN
   BCS ++
+  DEC LOADUFOUNT
   BNE -
   BEQ LOADEXTYTE

+  DEC LOADUFOUNT
   STX LOADUFTR
   STY LOADINEEN
   CLC
   RTS

LOADUF = *  ;( ) : .=EOF
   JSR STOPKEY
   BCS +
   LDA #<FILEBUF
   LDY #>FILEBUF
   STA ZP+0
   STY ZP+1
   LDA #<254
   LDY #>254
   LDX LOADCB
   JSR READ
   BCS +
   BEQ +
   STA LOADUFOUNT
   LDA #0
   STA LOADUFTR
   CLC
   RTS
+  SEC
   RTS

LOADINERAP = *
   LDX LOADINEEN
   DEX
   LDY #$00
   LDA LINE,X
   CMP #CHR
   BEQ +
   LDY #$80
+  STY LINELAGS
   CMP #CHR
   BNE +
-  STX LINEINEEN
   STX LOADINECAN
   STX LOADINEEN
   RTS

+  LDX LOADINEEN
   CPX TARGETEN
   BCC -

+  BIT WRAPLAG
   BMI +
-  LDA TARGETEN
   STA LOADINECAN
   STA LINEINEEN
   RTS

+  LDX TARGETEN
-  DEX
   CPX #255
   BEQ --
   LDA LINE,X
   CMP #" "
   BNE -
+  INX
   STX LOADINECAN
   STX LINEINEEN
   RTS

LOADINETORE = *
   LDA #<LINE
   LDY #>LINE
   STA ZP+0
   STY ZP+1
   LDA LINEINEEN
   LDY #0
   LDX #STDOUT
   JSR WRITE
   LDA #CHR
   JSR PUTCHAR
   RTS

LOADINEVERFLOW = *
   LDX LOADINECAN
   LDY #0
-  CPX LOADINEEN
   BCS +
   LDA LINE,X
   STA LINE,Y
   INX
   INY
   BNE -
+  STY LOADINEEN
   RTS

;=== MANAGEMENT ROUTINES ===

WORK3AVE .BUF 14

SAVEORK3 = *
   LDX #13
-  LDA WORK3,X
   STA WORK3AVE,X
   DEX
   BPL -
   RTS

RESTOREORK3 = *
   LDX #13
-  LDA WORK3AVE,X
   STA WORK3,X
   DEX
   BPL -
   RTS

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   STX XSAVE
   STY YSAVE
   LDX #STDOUT
   JSR PUTC
   LDX XSAVE
   LDY YSAVE
   RTS
   XSAVE .BUF 1
   YSAVE .BUF 1

PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   RTS

;===BSS===

BSS             = *
LINEBUF         = BSS+0  ;(256)
LINEEXTTR     = LINEBUF+$0 ;(4)
LINEREVTR     = LINEBUF+$4 ;(4)
LINEINEEN     = LINEBUF+$8 ;(1)
LINENDENT      = LINEBUF+$9 ;(1)
LINELAGS       = LINEBUF+$A ;(1) ;$80=CONNECTED, $40=TAILINE
LINE            = LINEBUF+$B ;(241)

FILEBUF         = LINEBUF+256  ;(256)
TPAREEMAP      = FILEBUF+256  ;(256)
BSSND          = TPAREEMAP+256
